#!/usr/bin/perl

$|=1;

# Script fonctionnant autant sur Windows que sur Unix, au prix de nombreuses acrobaties :-) #

print "Content-type: text/html\n\n";		# En-tte HTTP indispensable  envoyer, sinon a plante :-(
$VERSION='1.11';				# Version de ce CGI, ne pas toucher !

# V1.11:08/05/2000 : Problme corrig pour les fichiers ayant une extension 
#                    avec des caractres bizzares.
# V1.1 :01/05/2000 : Dtection DocumentRoot diffrente, plus souple.
# V1.0 :16/03/2000 : Version initiale.
##############################################################################
# Ceci est un script CGI en Perl, ralis par Sbastien Joncheray.           #
# Vous pouvez l'utiliser gratuitement,  la condition de ne pas changer son  #
# contenu, notamment, les parties faisant mentions de l'auteur.              #
# De nombreux autres scripts perl en francais, sont disponibles gratuitement #
# sur : http://www.perl-gratuit.com                                          #
#                                                                            #
# En cas de difficults d'installations veuillez consultez les FAQs et autres#
# sections d'aide sur www.perl-gratuit.com, avant d'envoyer un E-Mail SVP... #
##############################################################################
# Tous droits de modification/distribution/vente rservs                    #
# Merci de me contacter dans ces cas l :-)  (info@perl-gratuit.com)         #
##############################################################################

##############################################################################
# Si le script vous indique des messages d'erreurs, vous pouvez configurer   #
# les variables suivantes. Mais en principe, elles sont auto-dtectes :     #
# !! Modifiez-les uniquement si ce script ne fonctionne pas normalement !!   #
#$CONF{"PERL_BIN"}='';				# Emplacement de Perl sur le serveur
#$REAL_CURDIR='';				# Chemin complet du rpertoire o se trouve ce CGI sur le serveur
#$CONF{"DOC_ROOT"}='';				# Chemin complet au rpertoire racine du site web (DocumentRoot)
##############################################################################

# Quelques oprations  faire pour s'chauffer
# avant de commencer
&init;

# Rception donnes de formulaire,
# mthode GET ou POST :
if ($ENV{'REQUEST_METHOD'} eq 'POST') {
  %form=&receivepost;
} elsif ($ENV{'QUERY_STRING'} ne '') {
  %form=&receiveget;
}

# Le rpertoire en court est celui envoy par le formulaire
# ou celui par dfaut (pour le premier accs)
$REAL_CURDIR =( $form{'REAL_CURDIR'} || $REAL_CURDIR);		

# Pour modifier les noms de champ du type rep.xxx en rep=xxx
# et de test.yyy en test=yyy
foreach $key (keys(%form)) {
  if ($key=~ /^rep\.(.*)$/)  { $form{'rep'} =$1;  }
  if ($key=~ /^test\.(.*)$/) { $form{'test'}=$1; }
}

# Si le champ 'rep' n'est pas nul, on veut changer
# de rpertoire en cours
if ($form{'rep'} ne '') {
  $REAL_CURDIR=&change_rep($REAL_CURDIR,$form{'rep'});
}


  # Calcul du rpertoire virtuel en cours :
  if ($CONF{'DOC_ROOT'} ne '') {		# Si on connait le rp de base au site web :
    my ($tmp)=$CONF{'DOC_ROOT'};
    $tmp=~ s/\\/\\\\/g;
    if ($REAL_CURDIR=~ /^$tmp(.*)$/) {$VIRT_CURDIR=$1;}else {$VIRT_CURDIR='??';}
    $VIRT_CURDIR=~ s/\\/\//g;
  }

# SECURITE : On vrifie que le visiteur n'a pas demand  aller l o il ne devriat pas...
if ( ($CONF{'DOC_ROOT'} ne '') && ($REAL_CURDIR !~ /^$CONF{DOC_ROOT}/) ) {
  &msg_fin("$CGI_NAME <br>\n$CGI_DESC","Vous ne pouvez pas aller dans le rpertoire <b>$REAL_CURDIR</b>, car celui-ci semble tre en dehors de l'espace disque dur rserv  votre site...");  
}

if ($form{'ORDexplorateur'}) {			# Pour naviguer dans les rpertoires du site
  &explorateur;
} elsif ($form{'ORD_test_cw'}) {		# Pour faire le test complet d'un script Perl
  &test_script_cw;
} elsif ($form{'ORD_version'}) {		# Informations sur la version de ce script
  &admin_version;
} elsif ($form{'ORD_info'}) {			# Explications sur ce script
  &admin_info;
} elsif ($form{'test'}) {			# Test d'un script Perl
  &test_script;
}


&explorateur;					# Par dfaut : explorateur.






################################################
############                   #################
############  SOUS-PROGRAMMES  #################
############                   #################
################################################

################################################
sub init {
use Config;


  #### Configuration de base ###################
  $CGI_DESC='Testeur de Script';		# Description du CGI: NE PAS CHANGER SINON RIEN NE VA MARCHER !
  $CGI_NAME='pg-testscript';			# Nom du CGI: NE PAS CHANGER SINON RIEN NE VA MARCHER !!!!
  $PERL_TYPES='|pl|cgi|fcgi|wcgi|';		# Extensions de fichiers de type perl
  $CONF{BGCOLOR}="#DDDDDD";
  $CONF{'CGI_URL'}=($ENV{'REQUEST_URI'} || $ENV{'SCRIPT_NAME'}); # URL de ce CGI
  $CONF{'CGI_URL'}=~ s/\?.*//gs;
  $PGIMG_URL= $ENV{'SERVER_NAME'} eq '127.0.0.5' ? 'http://127.0.0.9/img-scripts' : 'http://img-scripts.perl-gratuit.com';
  $FONT='<font face="Arial,Verdana" size="2">';

  #### Dtection rpertoire en cours ###########
  $VIRT_CURDIR='';					# Rpertoire virtuel en cours
  if ($REAL_CURDIR eq '') {
    foreach $buf ($0,$ENV{'SCRIPT_FILENAME'},$ENV{'PATH_TRANSLATED'}) {
      if ($buf eq '') {next;}			# Si vide, on essaie le suivant
      if ($buf=~ /wrap/i) {next;}		# Si c'est le chemin au Wrapper, pas bon
      if ($buf=~ /sbox/i) {next;}		# Si c'est le chemin au Wrapper 'sbox', pas bon
      if (($^O!~ /win/i) && ($buf!~ /^\//)) {next;}# Si ne commence pas par /, c'est pas bon non plus (sauf pour du Windows)
      if (!-e "$buf") {next;}			# Si le fichier indiqu n'existe pas, pas bon
      $REAL_CURDIR=$buf;
      last;
    }
    $REAL_CURDIR=~ s/[^\/|\\]+$//;		# Enlve ce qui suit le dernier / ou \
    $REAL_CURDIR=~ s/[\/|\\]$//;		# Enlve le / ou \ final
    if ($^O=~ /win/i) {$REAL_CURDIR=~ s/\//\\/g;}	# Si on est sur Windows, on ne veut pas de /, mais des \
    $REAL_CGIDIR=$REAL_CURDIR;			# Chemin complet au rpertoire o se trouve le CGI
    if ($REAL_CURDIR eq '') {  &msg_fin("$CGI_NAME <br>\n$CGI_DESC","Impossible de trouver le chemin complet au rpertoire o est install ce CGI... Modifiez le script manuellement, et mettez le chemin complet (sur le disque dur du serveur) du rpertoire de ce CGI dans la ligne contenant <b>\$REAL_CURDIR</b>");  }
  }

  #### Caractre de sparation de rpertoires###
  $SEP= $^O=~ /win/i ? '\\' : '/';		# Si on est sur windows c'est \, sinon (Unix) c'est /

  #### Emplacement de Perl : ####
  if ($CONF{'PERL_BIN'} eq '') {
    foreach ('/usr/local/bin/perl','/usr/bin/perl',$Config{'perlpath'},"C:\\perl\\bin\\perl.exe") {
      if ( (-e "$_") && (-x "$_") ) {
        $CONF{'PERL_BIN'}=$_;
        last;
      }
    }
  }
  if ($CONF{'PERL_BIN'} eq '') {  &msg_fin("$CGI_NAME <br>\n$CGI_DESC","Impossible de trouver l'emplacement de Perl sur le serveur... Modifiez le script manuellement, et mettez l'emplacement de Perl dans la ligne contenant <b>\$CONF\{&quot;PERL_BIN&quot;\}</b>");  }


  #### Chemin complet au rpertoire de base du site web ####
  #### C'est un peu compliqu mais c'est la mthode la plus fiable que j'ai trouv, aprs avoir test sur
  #### une vingtaine de serveur diffrents.
  if ($CONF{'DOC_ROOT'} eq '') {
    my ($tmp_real_curdir,$tmp_cgi_dir);
    $tmp_real_curdir=$REAL_CURDIR;
    $tmp_real_curdir=~ s/\\/\//g;
    $tmp_cgi_dir=$CONF{'CGI_URL'};
    $tmp_cgi_dir=~ s/\\/\//g;
    $tmp_cgi_dir=~ s/[^\/]+$//;
    $tmp_cgi_dir=~ s/\/$//;

    if ($tmp_real_curdir=~ /^(.*)$tmp_cgi_dir/) {
      $CONF{'DOC_ROOT'}=$1;
    }
  }
  # On met bien les / ou \, et
  # on enlve le / (ou \ sur windows) ventuel en fin du chemin au rpertoire racine du site web
  if ($^O=~ /win/i) {
    $CONF{'DOC_ROOT'}=~ s/\//\\/g;
    $CONF{'DOC_ROOT'}=~ s/\\$//;
  } else {
    $CONF{'DOC_ROOT'}=~ s/\\/\//g;
    $CONF{'DOC_ROOT'}=~ s/\/$//;
  }
}
################################################
sub receivepost {
my (%postdata)=();
my ($len,$d,$data,$nom,$valeur)=();

  if ($ENV{'REQUEST_METHOD'} eq 'POST') {
    $len=$ENV{'CONTENT_LENGTH'};       # Longueur de l envoi
    $data='';                          # Chaine envoye
    if (read(STDIN,$data,$len) !=$len) {       # tout n est pas lu
      print ("<H1>error reading post data </H1>");
      die("Error reading 'POST' data\n") ; }
    foreach $d (split('&',$data)) {            # sparation de la chaine par paires
      ($nom,$valeur)=split('=',$d);      # paires spares
      $nom=&url_decode($nom);
      $valeur=&url_decode($valeur);
     $postdata{$nom}=$valeur;                  # paires ranges dans data
      }
    } else {
      print ("Content-type: text/html\n\n<H1>webmaster says : Post Error in CGI method <BR>GO BACK and TRY again</H1>Vous ne pouvez accder ici par ce moyen.");
      exit; 
    }
  return %postdata ;
}
################################################
sub url_decode {
  my ($s)=@_;
  $s=~ tr/+/ /;
  $s=~ s/%([0-9A-F][0-9A-F])/pack("C",oct("0x$1"))/ge;
  $s;
}
################################################
sub receiveget {
my (%postdata)=();
my ($data,$d,$nom,$valeur)=();

  if ($ENV{'REQUEST_METHOD'} eq 'GET') {
    $data=$ENV{'QUERY_STRING'};
    foreach $d (split('&',$data)) {            # sparation de la chaine par paires
      ($nom,$valeur)=split('=',$d);      # paires spares
      $nom=&url_decode($nom);
      $valeur=&url_decode($valeur);
      $postdata{$nom}=$valeur;                  # paires ranges dans data
    }
  } else {
    print ("Content-type: text/html\n\n<H1>webmaster says : GET Error in CGI method <BR>GO BACK and TRY again</H1>Vous ne pouvez accder ici par ce moyen.");
    die ("webmaster says : GET Error in CGI method") ; 
  }
  return %postdata ;
}
################################################
sub msg_fin {
my ($titre,$tip)=@_;

  ## ATTENTION, si vous modifiez ou supprimez les lignes ci-dessous, vous ne #
  ## respectez pas les conditions d'utilisation gratuite de ce programme, et #
  ## vous vous en servez de manire illgale ! Merci de respecter le travail #
  ## de l'auteur !                                                           #

  print <<_EOM_;
  <html>
  <head> <title>$CGI_NAME</title></head>
  <body bgcolor="$CONF{BGCOLOR}" text="#000000" link="#FF0000" vlink="#FF0000" alink="#FF0000">

  <p>&nbsp;</p>
  <div align="center"><center>

  <table border="0" width="80%">
    <tr>
      <td width="100%" bgcolor="#184692"><p align="center"><font face="Arial" color="#E9B61B"><B>$titre</B></font></td>
    </tr>
    <tr>
      <td width="100%" bgcolor="#EBCE76">
       <p>&nbsp;</p>
       $tip
       <p>&nbsp;</p>
      </tr>
    <tr>
      <td width="100%" bgcolor="#184692"><p align="center"><font face="Arial" size="1" color="#E9B61B"><strong>
       Script CGI Perl gratuit ralis par Sbastien Joncheray,
      disponible sur <a href="http://www.perl-gratuit.com">perl-gratuit.com</a>. v$VERSION &copy;</strong></font></td>
    </tr>
  </table>  </center></div>
  </body>
  </html>

_EOM_

  exit(0);
}
################################################
sub list_dir {
my ($repertoire)=@_;
my (@fichiers,$buf);

  opendir (DIR,"$repertoire") || (&msg_fin("$CGI_NAME <br>\n$CGI_DESC","Impossible de voir le contenu du rpertoire $repertoire: $!<br> Soit vous n\'tes pas autoris  voir ce rpertoire, soit les permissions ne sont pas bonnes."));
  while ($buf=readdir(DIR)) {
    push(@fichiers,$buf) if (($buf ne '.') && ($buf ne '..'));
  }
  closedir(DIR);
  return (@fichiers);
}
################################################
sub change_rep {
my ($repertoire,$selectdir)=@_;
  # Il ne doit pas y avoir de / ou \ dans le rpertoire o aller
  $selectdir=~s/^\\//g;
  $selectdir=~s/^\///g;

  if ($selectdir eq '..') {
    if ($repertoire eq $CONF{'DOC_ROOT'}) {
      &msg_fin("$CGI_NAME <br>\n$CGI_DESC",$FONT.'Vous tes dj  la racine de votre site, vous ne pouvez pas remonter au rpertoire suprieur.</font>');
    }
    if ($^O=~/win/i) {
      $repertoire=~ s/\\[^\\]+$//;
    } else {
      $repertoire=~ s/\/[^\/]+$//;
    }
  } else {
    $repertoire.=$SEP.$selectdir;
  }
  return ($repertoire);
}
################################################
sub explorateur {
my (@curdir_files)=();
my ($msg,$fichier,$extension,$buf);


  ## Dbut formulaire :
  $msg.="<form method=\"POST\" action=\"$CONF{CGI_URL}\">\n";
  $msg.="<input type=\"hidden\" name=\"REAL_CURDIR\" value=\"$REAL_CURDIR\">\n";
  $msg.="<div align=\"center\"><center><p>\n";
  $msg.='<input type="submit" name="ORD_version" value="Dernire version disponible de ce CGI"> &nbsp; ';
  $msg.='<input type="submit" name="ORD_info" value="INFORMATIONS A LIRE"><br>&nbsp'."\n";
  $msg.="</p></center></div>\n";

  ## On affiche le rpertoire en cours (complet, et virtuel)
  $msg.='<div align="center"><center><table border="0">'."\n";
  $msg.=" <tr>\n";
  $msg.="  <td> $FONT <b>Rpertoire complet courant :</b></font></td>\n";
  $msg.="  <td> $FONT <font color=\"#FF0000\"><b>$REAL_CURDIR$SEP</b></font></font></td>\n";
  $msg.=" </tr><tr>\n";
  $msg.="  <td> $FONT <b>Rpertoire virtuel courant :</b></font></td>\n";
  $msg.="  <td> $FONT <font color=\"#FF0000\"><b>$VIRT_CURDIR/<b></font></font></td>\n";
  $msg.="</tr>\n";
  $msg.="</table>\n\n";

  $msg.="<p align=\"center\">$FONT <font color=\"#0000A0\"><b><u>Contenu du rpertoire en cours :</u></b></font><br>";
  $msg.=" Dplacez-vous dans les rpertoires  l\'aide des boutons &quot;=&gt;&quot; ou &quot;&gt;&gt;&quot;<br>";
  $msg.=" puis cliquez sur le bouton &quot;Test&quot du script  vrifier</font></p>\n</center></div>\n";

  
  @curdir_files=&list_dir($REAL_CURDIR);	# On liste le contenu du rpertoire courant
  @curdir_files=(sort(@curdir_files));		# On trie la liste de faon alphabtique

  $msg.='<div align="center"><center><table border="0" cellspacing="0" cellpadding="0">'."\n";

  # Rpertoire Suprieur
  $msg.="<tr><td align=\"right\"><input type=\"submit\" name=\"rep...\" value=\">>\"> </td>   <td><font face=\"Verdana,Arial\" size=\"2\" color=\"#0000A0\"><b><i>&nbsp;Rpertoire Suprieur</i></b></font></td></tr>\n";

  # On affiche d'abord les rpertoires :
  foreach $fichier (@curdir_files) {
    if (-d "$REAL_CURDIR/$fichier") {		# Si c'est un rpertoire
      $msg.=" <tr><td align=\"right\"><input type=\"submit\" name=\"rep.$fichier\" value=\"=>\"> </td>";
      $msg.=" <td><font face=\"Verdana,Arial\" size=\"2\">&nbsp;<font color=\"#0000A0\"><b><i>Rpertoire</i></b></font>&nbsp; $fichier</font></td></tr>\n";
    }
  }

  $msg.='<tr><td colspan="2"><hr noshade color="#0000A0"></td></tr>'."\n";

  # On affiche ensuite les fichiers :
  foreach $fichier (@curdir_files) {
    if (!(-d "$REAL_CURDIR/$fichier")) {	# Si ce n'est pas un rpertoire
      if ( ($fichier=~ /\.([^\.]+)$/) && ($extension=$1) && ($extension!~ /\W/) && ($PERL_TYPES=~ /\|$extension\|/i) ) {
        # Si c'est un fichier de type script perl
        $msg.=" <tr><td align=\"right\"><input type=\"submit\" name=\"test.$fichier\" value=\"Test\"> </td>";
        $msg.=" <td><font face=\"Verdana,Arial\" size=\"2\">&nbsp;<b>$fichier</b></font></td></tr>\n";
      } else {	
        # Sinon
        $msg.=" <tr><td align=\"right\">-&nbsp; &nbsp; </td>";
        $msg.=" <td><font face=\"Verdana,Arial\" size=\"2\">&nbsp;$fichier</font></td></tr>\n";
      }
    }
  }
  $msg.="</table></center></div>\n\n";

  ## Fin formulaire :
  $msg.="</form>\n";

  &msg_fin("$CGI_NAME <br>\n$CGI_DESC",$msg);  
}
################################################
sub test_chmod {
my ($fichier)=@_;
my ($chmod,$reponse);

  if ($^O=~ /win/i) { return "Systme Windows, test non ncessaire";}
  $chmod=(stat($fichier)) [2];

  if (!($chmod & 0001)) {$reponse.="Script non autoris  l\'xcution pour les visiteurs web<br>\n";}
  if (!($chmod & 0004)) {$reponse.="Script non autoris en lecture pour les visiteurs web<br>\n";}
  if (!($chmod & 0010)) {$reponse.="Script non autoris  l\'xcution pour votre groupe<br>\n";}
  if (!($chmod & 0040)) {$reponse.="Script non autoris en lecture pour votre groupe<br>\n";}
  if (!($chmod & 0100)) {$reponse.="Script non autoris  l\'xcution pour le propritaire du fichier (vous)<br>\n";}
  if (!($chmod & 0400)) {$reponse.="Script non autoris en lecture pour le propritaire du fichier (vous)<br>\n";}

  if ($reponse ne '') {
    $reponse.="<i>Les permissions (chmod) sur ce fichier sont <u>".sprintf("%o",($chmod & 07777));
    $reponse.="</u> au lieu de 755 ou 777.<br>\n";
    $reponse.="Le serveur ne peut donc <u>probablement</u> pas xcuter ce CGI par le navigateur...</i>";
  }

  return ($reponse);
}
################################################
sub test_shebang {
my ($fichier)=@_;
my ($shebang);

  if ($^O=~ /win/i) { return "Systme Windows, test non ncessaire";}

  open (TSR,"$fichier") || (return "Impossible de lire le script. Test Annul: <i>$!</i>");
  $shebang=<TSR>;
  close (TSR);

  chomp($shebang); 
  $shebang=~ s/\s+$//;
  $shebang=~ s/\r.*//;				# Au cas o ce serait au format MAC, on coupe aprs le fin de ligne MAC

  # On vrifie que le shebang commence par:#!
  if ($shebang!~ /^\#\!/) {
    return "La premire ligne de votre script doit commencer par :<big><b>\#\!</b></big><br>\nLe script ne peut pas tre xcut dans l\'tat par le navigateur\n";
  }

  # On vrifie que le shebang correspond au programme xcutable
  $shebang=~ s/^\#\!//;
  if (!-e "$shebang") {
    return "La premire ligne de votre script indique un emplacement<br> erron de l\'interprteur Perl :<b>$shebang</b> n\'existe pas !<br>Mettez plutt :<br><b>\#\!$CONF{PERL_BIN}</b>";
  }
}
################################################
sub test_findeligne {
my ($fichier)=@_;
my (@ligne,$i,$reponse);


  ## On ouvre le fichier script CGI et on y lit les 10 premires lignes
  open (TFR,"$fichier") || (return "Impossible de lire le script. Test Annul: <i>$!</i>");
  # binmode indispensable, sinon Perl arrange les fins de ligne entre DOS et Unix
  binmode (TFR);
  $i=0;
  while (($i<10) && ($ligne[$i]=<TFR>) ) {
    $i++;
  }
  close (TFR);

  # On regarde les $nb_lues premires lignes du script ainsi lues,
  # et on vrifie que les caractres de fin de ligne sont bien
  # \n sur Unix, ou \r\n sur Windows.
  # Caractres fin de ligne :
  # Unix      : \010 (\n)
  # Windows   : \013\010 (\r\n)
  # Macintosh : \013 (\r)

  for ($i=0;$i<$#ligne;$i++) {

    if ($^O=~ /win/i) {				# Si serveur Windows...
      if (($ligne[$i]=~ /\r/) && ($ligne[$i]!~ /\n/)) {	# Si la ligne contient \r et pas de \n, caractristique de fin de ligne MAC
        $reponse= "Le fichier contient des caractres de fin de ligne de type MAC,<br> ce qui n\'est pas comprhensible par votre serveur de type Windows. ";
        last;
      }
      if ($ligne[$i]!~ /\r/) {
        $reponse= "Le fichier contient des caractres de fin de ligne de type UNIX,<br> ce qui n\'est pas comprhensible par votre serveur de type Windows. ";
        last;
      }

    } else {					# Serveur Unix
      if ($ligne[$i]=~ /\r\n/) {
        $reponse= "Le fichier contient des caractres de fin de ligne de type MSDOS/Windows,<br> ce qui n\'est pas comprhensible par votre serveur de type Unix. ";
        last;
      }
      if ($ligne[$i]=~ /\r/) {
        $reponse= "Le fichier contient des caractres de fin de ligne de type MAC,<br> ce qui n\'est pas comprhensible par votre serveur de type Unix. ";
        last;
      }
    }
  }

  if ($reponse ne '') {
    $reponse.="<br>\n<i>Retlchargez le script par FTP en mode ASCII/texte.<br>\n";
    $reponse.="Voyez les \"fiches pratiques/FAQs\" sur www.perl-gratuit.com, pour les dtails.</i>";
  }
  return ($reponse);
}
################################################
sub test_script {
my ($msg);

  if (!-e "$REAL_CURDIR$SEP$form{'test'}") {
    &msg_fin("$CGI_NAME <br>\n$CGI_DESC","$FONT Le fichier $REAL_CURDIR$SEP$form{'test'} n\'existe pas ou plus !</font>");
  }

  ## Dbut formulaire :
  $msg.="<form method=\"POST\" action=\"$CONF{CGI_URL}\">\n";
  $msg.="<input type=\"hidden\" name=\"REAL_CURDIR\" value=\"$REAL_CURDIR\">\n";
  $msg.="<input type=\"hidden\" name=\"test\" value=\"$form{'test'}\">\n";
  $msg.="<div align=\"center\"><center><p>\n";
  $msg.='<input type="submit" name="ORD_version" value="Dernire version disponible de ce CGI"> &nbsp; ';
  $msg.='<input type="submit" name="ORD_info" value="INFORMATIONS A LIRE"><br>&nbsp'."\n";
  $msg.="</p></center></div>\n";

  ## On affiche le rpertoire en cours (complet, et virtuel)
  $msg.='<div align="center"><center><table border="0">'."\n";
  $msg.=" <tr>\n";
  $msg.="  <td> $FONT <b>Rpertoire complet courant :</b></font></td>\n";
  $msg.="  <td> $FONT <font color=\"#FF0000\"><b>$REAL_CURDIR$SEP</b></font></font></td>\n";
  $msg.=" </tr><tr>\n";
  $msg.="  <td> $FONT <b>Rpertoire virtuel courant :</b></font></td>\n";
  $msg.="  <td> $FONT <font color=\"#FF0000\"><b>$VIRT_CURDIR/<b></font></font></td>\n";
  $msg.="</tr>\n";
  $msg.="</table>\n\n";

  $msg.="<p align=\"center\"><font face=\"Arial\" color=\"#0000A0\"><b>TEST de $VIRT_CURDIR/$form{'test'} :</b></font></p>\n";

  # Tests
  $msg.='<table border="0">'."\n";
  $msg.="<tr>\n";
  # test CHMOD :
  $msg.=" <td valign=\"top\">$FONT <b>Test 1 (chmod) :</b> </font></td>\n";
  $msg.=" <td>$FONT".(&test_chmod($REAL_CURDIR.$SEP.$form{'test'}) || 'OK')." </font></td>\n";
  # test sheebang
  $msg.="</tr><tr>\n";
  $msg.=" <td valign=\"top\">$FONT <b>Test 2 (shebang) :<br></b> </font></td>\n";
  $msg.=" <td>$FONT".(&test_shebang($REAL_CURDIR.$SEP.$form{'test'}) || 'OK')." </font></td>\n";
  # test upload FTP ASCII (fin de ligne)
  $msg.="</tr><tr>\n";
  $msg.=" <td valign=\"top\">$FONT <b>Test 3 (envoi FTP ASCII/texte) :<br></b> </font></td>\n";
  $msg.=" <td>$FONT".(&test_findeligne($REAL_CURDIR.$SEP.$form{'test'}) || 'OK')." </font></td>\n";

  $msg.="</table>\n";


  # on tente de faire perl -c sur le script pour vrifier la syntaxe :
  eval {
    if ($^O=~ /win/i) {
      chdir($REAL_CURDIR);
      open (STDERR,">".$REAL_CGIDIR.$SEP."stderr.txt") || (  &msg_fin("$CGI_NAME <br>\n$CGI_DESC","Votre serveur tant du type Windows,
                                                    ce script a besoin de crer un fichier temporaire nomm <b>stderr.txt</b>,
                                                    mais il n\'y arrive pas.<br> Merci de crer vous-mme ce fichier vide, dans
                                                    le mme rpertoire que ce CGI, et de l\'autoriser en criture... Rechargez ensuite cette page."));  
      $res=`$CONF{PERL_BIN} -c $form{test}`;
      close (STDERR);
      open (LR,$REAL_CGIDIR.$SEP."stderr.txt") || print "Impossible de rcuprer le rsultat du test :$!";
      while (<LR>) {$res.=$_;}
      close (LR);
    } else {					# Si on est sur Unix
      $res=`cd $REAL_CURDIR; $CONF{PERL_BIN} -c $form{test} 2>&1`; # OK SUR UNIX PAS WINDOWS
    }
    $res=~ s/\n$//;
    $res=~ s/</&lt/gs;
    $res=~ s/>/&gt/gs;
    $res=~ s/\"/&quot;/gs;
    $res=~ s/\n/<br>\n/g;
  };
  
  $msg.='<table border="1" cellpadding="6" cellspacing="0">'."\n";
  $msg.="<tr><td>\n";

  if ($@) {
    $msg.="<p align=\"center\"><b>$FONT Contrle de la syntaxe du script Perl : <font color=\"#FF0000\">??</font></b><br>&nbsp;<br>\n";
    $msg.= "Impossible de tester le script avec \"perl -c\" :$@ </font></p>\n";
  } else {
    if ($res=~ /syntax OK/i) {
      $msg.="<p align=\"center\"><b>$FONT Contrle de la syntaxe du script Perl : <font color=\"#FF0000\">OK</font></b><br>&nbsp;<br>\n";
      $msg.= " Aucune erreur de syntaxe :-)</font></p>\n";
    } else {
      $msg.="<p align=\"center\"><b>$FONT Contrle de la syntaxe du script Perl : <font color=\"#FF0000\">ERREUR !</font></b><br>&nbsp;<br>\n";
      $msg.= "Ce script contient au moins une erreur :</font></p>\n";
    }
    $msg.="<p>$FONT <u>Message complet retourn par Perl en mode vrification (perl -c): </u><br>&nbsp;<br>\n".$res."\n</font></p>\n";
  }

  $msg.="</td></tr></table>\n\n";

  ## Bouton et fin de formulaire :
  $msg.="<p align=\"center\"> $FONT Si votre script ne contient pas d\'erreur de syntaxe, vous pouvez lancer ";
  $msg.="un test plus complet (perl -cw, affichage d\'avertissements) ";
  $msg.="en cliquant ci-dessous. Sinon, revenez  la page de slection de script :</font><br>&nbsp;<br>\n";
  $msg.='<input type="submit" name="ORD_test_cw" value="Test Complet"> ou <input type="submit" name="ORDexplorateur" value="Retour..."></p>'."\n";

  $msg.="</form></center></div>\n";

  &msg_fin("$CGI_NAME <br>\n$CGI_DESC",$msg);  
}
################################################
sub test_script_cw {
my ($msg);

  if (!-e "$REAL_CURDIR$SEP$form{'test'}") {
    &msg_fin("$CGI_NAME <br>\n$CGI_DESC","$FONT Le fichier $REAL_CURDIR$SEP$form{'test'} n\'existe pas ou plus !</font>");
  }

  ## Dbut formulaire :
  $msg.="<form method=\"POST\" action=\"$CONF{CGI_URL}\">\n";
  $msg.="<input type=\"hidden\" name=\"REAL_CURDIR\" value=\"$REAL_CURDIR\">\n";
  $msg.="<div align=\"center\"><center><p>\n";
  $msg.='<input type="submit" name="ORD_version" value="Dernire version disponible de ce CGI"> &nbsp; ';
  $msg.='<input type="submit" name="ORD_info" value="INFORMATIONS A LIRE"><br>&nbsp'."\n";
  $msg.="</p></center></div>\n";

  ## On affiche le rpertoire en cours (complet, et virtuel)
  $msg.='<div align="center"><center><table border="0">'."\n";
  $msg.=" <tr>\n";
  $msg.="  <td> $FONT <b>Rpertoire complet courant :</b></font></td>\n";
  $msg.="  <td> $FONT <font color=\"#FF0000\"><b>$REAL_CURDIR$SEP</b></font></font></td>\n";
  $msg.=" </tr><tr>\n";
  $msg.="  <td> $FONT <b>Rpertoire virtuel courant :</b></font></td>\n";
  $msg.="  <td> $FONT <font color=\"#FF0000\"><b>$VIRT_CURDIR/<b></font></font></td>\n";
  $msg.="</tr>\n";
  $msg.="</table>\n\n";

  $msg.="<p align=\"center\"><font face=\"Arial\" color=\"#0000A0\"><b>TEST COMPLET AVEC AVERTISSEMENTS de $VIRT_CURDIR/$form{'test'} :</b></font></p>\n";

  # on tente de faire perl -cw sur le script pour vrifier la syntaxe :
  eval {
    if ($^O=~ /win/i) {
      chdir($REAL_CURDIR);
      open (STDERR,">".$REAL_CGIDIR.$SEP."stderr.txt") || (  &msg_fin("$CGI_NAME <br>\n$CGI_DESC","Votre serveur tant du type Windows,
                                                    ce script a besoin de crer un fichier temporaire nomm <b>stderr.txt</b>,
                                                    mais il n\'y arrive pas.<br> Merci de crer vous-mme ce fichier vide, dans
                                                    le mme rpertoire que ce CGI, et de l\'autoriser en criture... Rechargez ensuite cette page."));  
      $res=`$CONF{PERL_BIN} -cw $form{test}`;
      close (STDERR);
      open (LR,$REAL_CGIDIR.$SEP."stderr.txt") || print "Impossible de rcuprer le rsultat du test :$!";
      while (<LR>) {$res.=$_;}
      close (LR);
    } else {					# Si on est sur Unix
      $res=`cd $REAL_CURDIR; $CONF{PERL_BIN} -cw $form{test} 2>&1`; # OK SUR UNIX PAS WINDOWS
    }
    $res=~ s/^\n//;
    $res=~ s/\n$//;
    $res=~ s/</&lt/gs;
    $res=~ s/>/&gt/gs;
    $res=~ s/\"/&quot;/gs;
    $res=~ s/\n/<br>\n/g;
  };
  
  $msg.='<table border="1" cellpadding="6" cellspacing="0">'."\n";
  $msg.="<tr><td>\n";

  if ($@) {
    $msg.="<p align=\"center\"><b>$FONT Contrle de la syntaxe du script Perl et avertissements : <font color=\"#FF0000\">??</font></b><br>&nbsp;<br>\n";
    $msg.= "Impossible de tester le script avec \"perl -cw\" :$@ </font></p>\n";
  } else {
    if (($res=~ /syntax OK/i) && ($res=~ /\n/) ) {
      $msg.="<p align=\"center\"><b>$FONT Contrle de la syntaxe du script Perl et avertissements : <font color=\"#FF0000\">AVERTISSEMENT(S)</font></b><br>&nbsp;<br>\n";
      $msg.= " Aucune erreur de syntaxe, mais <u>messages d\'avertissement</u> :-)</font></p>\n";
    } elsif ($res=~ /syntax OK/i) {
      $msg.="<p align=\"center\"><b>$FONT Contrle de la syntaxe du script Perl et avertissements : <font color=\"#FF0000\">OK</font></b><br>&nbsp;<br>\n";
      $msg.= " Aucune erreur de syntaxe <u>ni messages d\'avertissement</u> :-)</font></p>\n";
    } else {
      $msg.="<p align=\"center\"><b>$FONT Contrle de la syntaxe du script Perl et avertissements : <font color=\"#FF0000\">ERREUR !</font></b><br>&nbsp;<br>\n";
      $msg.= "Ce script contient au moins une erreur de syntaxe et avertissements ventuels :</font></p>\n";
    }
    $msg.="<p>$FONT <u>Message complet retourn par Perl en mode vrification et warning (perl -cw): </u><br>&nbsp;<br>\n".$res."\n</font></p>\n";
  }

  $msg.="</td></tr></table>\n\n";

  ## Bouton et fin de formulaire :
  $msg.='<p align="center"><input type="submit" name="ORDexplorateur" value="Retour..."></p>'."\n";

  $msg.="</form></center></div>\n";

  &msg_fin("$CGI_NAME <br>\n$CGI_DESC",$msg);  


}
################################################
################################################
################################################
sub admin_version {
my ($msg);

  $msg=<<_EOM4_;
    <p align="center"><u><font face="Arial" color="#0000FF"><strong>Version :</strong></font></u></p>
    <blockquote>
      <p><font face="Arial" size="2">Cette page vous indique <u>en temps rel</u> s'il existe
      une version plus rcente de ce CGI sur le serveur de perl-gratuit.com.<br>
      Si vous constatez que c'est le cas, vous pouvez aller voir sur ce serveur le dtail des
      ajouts ou corrections ventuelles de ce CGI, et tlcharger ventuellement la nouvelle
      version.<br>
      </font></p>
    </blockquote>
    <div align="center"><center><table border="0" cellpadding="2" cellspacing="1">
      <tr>
        <td><font face="Arial" size="2"><b>La version de ce CGI est :</b></font></td>
        <td><font face="Arial" size="2" color="#0000FF"><b>$VERSION</b></font></td>
      </tr>
      <tr>
        <td><p align="center"><font face="Arial" size="2"><b>La dernire version disponible est : </b></font></td>
        <td><img src="$PGIMG_URL/$CGI_NAME\_vnumber.gif" border="0"></td>
      </tr>
    </table>
    </center></div>
    <p align="center"><font face="Arial" size="2">Remarque ventuelle sur la dernire version :<br>
    <img src="$PGIMG_URL/$CGI_NAME\_vnote.gif" border="0"></font></p>

<p align="center"><font face="Arial" size="2"> Vous trouverez la dernire
    version disponible sur <a href="http://www.perl-gratuit.com">www.perl-gratuit.com</a>.</font></p>
    <center><p align=\"center\">
      <form method="POST" action="$CONF{CGI_URL}">
      <input type="hidden" name="REAL_CURDIR" value="$REAL_CURDIR"> 
      <input type="submit" value="Retour..."></form>
    </p></center>
    <p>&nbsp;</p>

_EOM4_

  &msg_fin("<img src=\"$PGIMG_URL/$CGI_NAME.gif\" ALT=\"$CGI_NAME\"><br>$CGI_DESC",$msg);
}
################################################
################################################
sub admin_info {
my ($msg);

$msg=<<_EOM3_;
    <p align="center"><font face="Arial" color="#0000FF" size="3"><u><strong> Informations
    sur l'Utilisation de $CGI_NAME :</strong></u></font></p>
    
    <p><font face="Arial" size="2"><u><B>Scurit, ATTENTION :</B></u><br>
      Etant donn que ce CGI permet de voir le contenu des diffrents rpertoires du site sur lequel il est install,
      vous devriez le renommer avec un nom peu commun voire compliqu, afin d'viter que des visiteurs
      puissent le trouver, ou, mieux encore, le supprimer de votre site web aprs l'avoir utilis.</font></p>

    <p><font face="Arial" size="2"><u><B>Informations diverses :</B></u><br>
     <UL>
     <LI><b>Configuration/Auto-Configuration :</b> Ce CGI tente de dtecter de nombreux paramtres, afin que
       vous n'ayez pas besoin de modifier ce script.<br>
       Elments auto-dtects : Emplacement de Perl <small>(si non trouv, vous devrez l'indiquer
       vous-mme)</small>, URL de ce CGI, chemin complet au rpertoire de ce CGI sur le disque dur du serveur,
       type de serveur (Unix/Windows) et caractre de sparation de rpertoire (\\ ou /), chemin complet 
       du rpertoire de base de votre site web.<br>
       Si vous notez que l\'auto-configuration fonctionne mal, merci de m'crire afin que j'amliore...<br>&nbsp; <br>
     </LI>
     <LI><b>Compatibilit Windows :</b> Ce script est conu pour fonctionner galement sur serveur Windows.<br>
       Pour ce faire, ce CGI dtecte si le serveur est du type Windows ou autre (Unix), et les mthodes de 
       navigation dans les rpertoires, et de test des scripts Perl sont diffrentes dans les 2 cas.
       Ce CGI a t test avec succs avec OmniHttpdv2.06 et Apache sur Windows 95/98 (en plus de tests
       sur diffrents systmes Unix), avec une version rcente de Perl pour Windows.<br>
       A l'heure actuelle, des tests plus complets manquent sur Windows NT, si vous rencontrez des
       problmes sur ce type de machine, merci de m'en avertir SVP.<br>&nbsp; <br>
     </LI>
     <LI><b>Pour choisir le fichier Perl  tester :</b> Dplacez-vous dans les rpertoires (par dfaut, celui
       qui contient ce CGI), puis cliquez sur le bouton \"TEST\" devant le script Perl  tester.<br>
       Seuls les fichiers dont l'extension est .pl ou .cgi ou .fcgi ou .wcgi peuvent tre tests.<br>&nbsp; <br>
     </LI>
     <LI><b>Rpertoire complet courant :</b> C'est le chemin complet du rpertoire dont le contenu est
       list au-dessous.<br>&nbsp; <br>
     </LI>
     <LI><b>Rpertoire virtuel courant :</b> C'est le chemin <i>par rapport au rpertoire de base de
       votre site</i> au rpertoire dont le contenu est list au-dessous.<br>
       S'il commence par <b>??</b>, c'est que ce CGI ne peut pas le dtecter, ce qui n'est pas gnant.<br>&nbsp; <br>
     </LI>
     <LI><b>Test1 (chmod) :</b> Ce CGI vrifie que le script  tester a les bonnes permissions.
      Si les permissions sont incorrectes (diffrent de 755 ou 777), le script test ne pourra pas s'xcuter
      normalement avec le navigateur (sauf pour quelques rares serveurs).<br>
      Ce test est ignor si votre serveur est Windows, car le systme de permission est diffrent.<br>&nbsp; <br>
     </LI>
     <LI><b>Test2 (shebang) :</b> Ce CGI vrifie que la premire ligne (appele shebang) du script  tester
      contient bien \"\#!\" suivi de l'emplacement <u>CORRECT</u> de l'interprteur Perl.
      Si ce n'est pas le cas, le script test ne pourra pas s'xcuter normalement avec le navigateur.<br>
      Ce test n\'est pas effectu si votre serveur est Windows, car le shebang y est ignor.<br>&nbsp; <br>
     </LI>
     <LI><b>Test3 (envoi FTP ASCII/Texte) :</b> Ce CGI vrifie que le fichier a bien t tlcharg par FTP en mode
      ASCII/Texte et non pas en mode binaire, les caractres de fin de ligne tant diffrents sur Unix, Windows
      et Macintosh. Dans ce test les 10 premires lignes du script  tester sont lues et analyses pour savoir
      si les caractres de fin de ligne sont conformes au systme d'exploitation de votre serveur.
      Si ce n'est pas le cas, le script test ne pourra pas s'xcuter normalement avec le navigateur.<br>&nbsp; <br>
     </LI>
     <LI><b>Test de la syntaxe :</b> Ce CGI lance le vrificateur de syntaxe de Perl (debogueur) pour le 
      script  tester (perl -c nom-du-fichier.pl), intercepte le message renvoy, et vous l'affiche aprs 
      analyse/traitement. La mthode employe est relativement diffrente selon que votre serveur est de type
      Unix ou Windows.<br>
      Si ce test vous indique des erreurs de syntaxe, il n'y a aucune chance pour que le script test
      fonctionne normalement avec le navigateur.<br>&nbsp; <br>
     </LI>
     <LI><b>Test de la syntaxe avec avertissements :</b> Ce CGI lance le vrificateur de syntaxe de Perl 
     (debogueur) avec affichage de \"Warnings\" (avertissements sur l'utilisation non rigoureuse de variables)
      pour le script  tester (perl -cw nom-du-fichier.pl), intercepte le message renvoy, et vous l'affiche
      aprs analyse/traitement. La mthode employe est relativement diffrente selon que votre serveur est de type
      Unix ou Windows.<br>
      Si ce test vous indique des <i>avertissements</i>, mais pas d'erreurs de syntaxe, il pourra quand mme
      fonctionner tout  fait normallement, en tant que CGI.<br>&nbsp; <br>
     </LI>


</font></p>
</UL>    
    <p><font face="Arial" size="2"><u><B>Copyright et Licence d'Utilisation :</B></u><br>
    Merci de ne pas enlever le copyright et les mentions de l'auteur du code
    source de ce CGI Perl...<br>
    La licence d'utilisation gratuite de ce script CGI vous est accorde  la condition
    expresse que vous ne fassiez pas de modifications dans le script CGI en vue de supprimer
    ou altrer ce type de mention. Dans le cas contraire, son utilisation est illgale...<br>
    Ceci est un change correct de services rendus :-)<br>
    <u>Distribution/revente interdite sans accord de l'auteur.</u> </p>
    <center><p align=\"center\">
      <form method="POST" action="$CONF{CGI_URL}">
      <input type="hidden" name="REAL_CURDIR" value="$REAL_CURDIR"> 
      <input type="submit" value="Retour..."></form>
    </p></center>
   <p>&nbsp;</p>

_EOM3_


  &msg_fin("<img src=\"$PGIMG_URL/$CGI_NAME.gif\" ALT=\"$CGI_NAME\"><br>$CGI_DESC",$msg);
}
################################################
################################################
################################################

